double squeeze (double F_a, double F_e, double dur, double pha)
    {
     double dur, om1, om2;
     double phe, phdif1, phdif2, phrest;
     double F_e2, slo_fre;

     om1 = ((F_a + F_e) /2) * pi2 ;         /* average phase velocity */
     phdif1 = om1 * dur ;                   /* phase diff until end */
     phe = pha + phdif1;                    /* phase at end */
     phrest = fmod (phe, pi2);              /* residual phase */
     phdif2 = phdif1 - phrest;              /* adapted phase diff to end */
     if (phdif2 < 0) phdif2 = phdif2 + pi2; /* rounding up */
     om2 = phdif2 / dur;                    /* adapted average velocity */
     F_e2 = ((2 * om2) / pi2) - F_a;        /* adapted End Frequency */
     slo_fre = (F_e2 - F_a) / dur;          /* slope of formant frequency */
  /*   printf ("\n F_e2 %lf", F_e2);  getch();
     printf ("\n slo_fre %lf", slo_fre);  getch();     */
     return (slo_fre);
    }


