/*
* Synthesemodul, das auf einem ASCII-File aufbaut, der
* alle pitch-frames vollstndig spezifiziert. Diese Datei
* kann entweder automatisch erstellt oder manuell editiert
* werden.

* Zur Zeit werden stimmlose Intervalle einfach als Pausen
* realisiert, in die dann mit anderen Programmen ein Inhalt
* hineingeflickt werden kann.
*/


#include <stdio.h>
#include <malloc.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <math.h>

/******************************************************************/

/* Header fuer Akustikdaten (Waveformat)           */
struct WAV_HEAD                  /* 44 Byte lang */
       {
         char                RIFF[4];
         unsigned long int   FILE_LENGTH;
         char                WAVEFMT[8];
         unsigned long int   HEAD_LENGTH;
         unsigned int        ONE;
         unsigned int        N_CHANNELS;
         unsigned long int   SAMPLINGRATE;
         unsigned long int   BYTEPERSECOND;
         unsigned int        BYTEPERSAMPLE;
         unsigned int        BITPERSAMPLE;
         char                DATA[4];
         unsigned long int   BYTEOFDATA;
       } head;

double pi2 ;

void main(int argc,char *argv[])
{
     unsigned long int gro, n, nperiods;

     char string[160], sccfile[]="scc.sc", uspfile[]="usp.sc" ;
     int   yint;
     double sampr, sampd;
     double y, yn, yv ;
     double p1, p2, F0, B0, pla1, pla2;
     double f1_rel,f2_rel,f3_rel,f4_rel,f5_rel;
     double add, pi2, period;
     double fra_start, fra_stop, delta, time, freq;
     double intvoi, intnoi1, intnoi2, point, ampl;
     double slo_b1, slo_b2, slo_b3, slo_b4, slo_b5;
     double F1a,F2a,F3a,F4a,F5a,B1a,B2a,B3a,B4a,B5a;
     double F1e,F2e,F3e,F4e,F5e,B1e,B2e,B3e,B4e,B5e;
     double slo_f1, slo_f2, slo_f3, slo_f4, slo_f5;
     double slo_rise, slo_fall, slo_noi, slo_phn;
     double phase1, phase2, phase3, phase4, phase5, phase0;
     double pha_n1, pha_n2, pha_n3, pha_n4, pha_n5;
     double pha_noi, pha_noi1, pha_noi2;
     unsigned seed=2;
     FILE  *asc , *wav, *usp;

     srand( (unsigned) 5 );
     pi2 = (double) 2. * acos(-1.);

/******************* evaluate arguments ****************************/

   if (argc < 3)
      {
        printf("\nFor TUESYN6.EXE, 3 arguments are required:");
        printf("\n       -  Ascii file containing frame information");
        printf("\n       -  new signal WAV-file name");
        printf("\n       -  sampling rate of new WAV-file");
      }

   asc = fopen(argv[1],"rt");                  /* open frames file */
         if (asc == 0)
             { printf("\nNo frames file found\n");
               exit (-1);
             }

   wav = fopen(argv[2],"wb");               /* signal file */

   sscanf (argv[3],"%lf",&sampr)  ;        /* formants file Sampling rate */

   sampd= 1/sampr;

   usp = fopen(uspfile,"wb");


   pi2 = (double) 2. * acos(-1.);

/* ******************  setting initial values ************************** */

point       = sampd;                    /* time of first sample point */
fra_start   = 0;                       /* time of first pitch frame onset */
gro         = 0;                       /* number of samples synthesized */

       pha_n1   = 0;
       pha_n2   = 0;
       pha_n3   = 0;
       pha_n4   = 0;
       pha_n5   = 0;

while   (fgets(string,150,asc)!=0)           /* pitch periods loop */
 {
                                                  /* read three lines */
  sscanf (string,"%ld%lf%lf%lf%lf%lf%lf%lf",
          &nperiods,&time,&period,&intvoi,&p1,&p2,&F0,&B0);
  fgets(string,150,asc) ;
  sscanf (string,"%lf%lf%lf%lf",
          &intnoi1,&intnoi2,&pha_noi1,&pha_noi2);
  fgets(string,150,asc) ;
  sscanf (string,"%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf",
          &F1a,&B1a,&F2a,&B2a,&F3a,&B3a,&F4a,&B4a,&F5a,&B5a);
  fgets(string,150,asc) ;
  sscanf (string,"%lf%lf%lf%lf%lf%lf%lf%lf%lf%lf",
          &F1e,&B1e,&F2e,&B2e,&F3e,&B3e,&F4e,&B4e,&F5e,&B5e);

                                         /* computation of slopes */
       slo_f1   = (F1e-F1a) / period;     /* for linear interpolation */
       slo_f2   = (F2e-F2a) / period;     /* for linear interpolation */
       slo_f3   = (F3e-F3a) / period;     /* for linear interpolation */
       slo_f4   = (F4e-F4a) / period;     /* for linear interpolation */
       slo_f5   = (F5e-F5a) / period;     /* for linear interpolation */

/*       sln_f1   = squeeze(F1a,F1e,period,pha_n1);
       sln_f2   = squeeze(F2a,F2e,period,pha_n2);
       sln_f3   = squeeze(F3a,F3e,period,pha_n3);
       sln_f4   = squeeze(F4a,F4e,period,pha_n4);
       sln_f5   = squeeze(F5a,F5e,period,pha_n5);       */

       slo_b1   = (B1e-B1a) / period;     /* for linear interpolation */
       slo_b2   = (B2e-B2a) / period;     /* for linear interpolation */
       slo_b3   = (B3e-B3a) / period;     /* for linear interpolation */
       slo_b4   = (B4e-B4a) / period;     /* for linear interpolation */
       slo_b5   = (B5e-B5a) / period;     /* for linear interpolation */

       slo_noi  = (intnoi2 - intnoi1) / period;
       slo_phn  = (pha_noi2 - pha_noi1) / period;

       phase0   = 0;
       phase1   = 0;
       phase2   = 0;
       phase3   = 0;
       phase4   = 0;
       phase5   = 0;

       fra_stop = fra_start + period;

          pla1 = fra_start + (period * (p1/100));   /* end of rise phase */
          pla2 = pla1 + (period * (p2/100));        /* end of plateau    */
          slo_rise = 0;
          slo_fall = 0;
          if (p1 != 0)
          slo_rise = intvoi / (pla1 - fra_start);    /* steepness of rise */
          if (p2 != 100)
          slo_fall = intvoi / (fra_stop - pla2);    /* steepness of fall */

/* ------------------------------------------------- */
          while (point < fra_stop)           /* voiced frame samples loop */
             {
              delta  = point - fra_start  ;          /* time within frame */

              phase0 = phase0 + ((pi2 * F0) * sampd);  /* pitch phase */

              freq   = F1a  + (slo_f1 * delta);          /* Formant    */
              phase1 = phase1 + ((pi2 * freq) * sampd);  /* phases     */
              f1_rel = (B1a + (slo_b1 * delta))/100;     /* and rel.   */
              freq   = F2a  + (slo_f2 * delta);          /* amplitudes */
              phase2 = phase2 + ((pi2 * freq) * sampd);
              f2_rel = (B2a + (slo_b2 * delta))/100;
              freq   = F3a  + (slo_f3 * delta);
              phase3 = phase3 + ((pi2 * freq) * sampd);
              f3_rel = (B3a + (slo_b3 * delta))/100;
              freq   = F4a  + (slo_f4 * delta);
              phase4 = phase4 + ((pi2 * freq) * sampd);
              f4_rel = (B4a + (slo_b4 * delta))/100;
              freq   = F5a  + (slo_f5 * delta);
              phase5 = phase5 + ((pi2 * freq) * sampd);
              f5_rel = (B5a + (slo_b5 * delta))/100;

                                                 /* amplitude profile   */
              if (point < pla1)
               { ampl = delta * slo_rise;           }       /* rise    */

              else if ((point >= pla1) && (point <= pla2))
               { ampl = intvoi;   }                          /* plateau */

              else
               { ampl = intvoi - ((point-pla2) * slo_fall) ;}   /* fall    */

              y      = 0                           ;
              y      = y + (f1_rel * sin(phase1))  ;
              y      = y + (f2_rel * sin(phase2))  ;
              y      = y + (f3_rel * sin(phase3))  ;
              y      = y + (f4_rel * sin(phase4))  ;
              y      = y + (f5_rel * sin(phase5))  ;
              y      = (y * ampl) + ((intvoi * (B0/100)) * sin(phase0)) ;
              yv     = y ;       /* voiced part of the period
----------------------------------------------------------------------- */
              pha_noi= pha_noi1 + (slo_phn * delta);
              add    = ((rand()-16383.5) / 16383.5) * (pi2 * pha_noi);
           /*   printf("\nadd=%lf",add);   */
              freq   = F1a + (slo_f1 * delta);       /* local F1 freq */
              pha_n1 = pha_n1 + ((pi2 * freq) * sampd) + add;
              f1_rel = (B1a + (slo_b1 * delta))/100;
              freq   = F2a + (slo_f2 * delta);       /* local F2 freq */
              pha_n2 = pha_n2 + ((pi2 * freq) * sampd) + add;
              f2_rel = (B2a + (slo_b2 * delta))/100;
              freq   = F3a + (slo_f3 * delta);       /* local F3 freq */
              pha_n3 = pha_n3 + ((pi2 * freq) * sampd) + add;
              f3_rel = (B3a + (slo_b3 * delta))/100;
              freq   = F4a + (slo_f4 * delta);       /* local F4 freq */
              pha_n4 = pha_n4 + ((pi2 * freq) * sampd) + add;
              f4_rel = (B4a + (slo_b4 * delta))/100;
              freq   = F5a + (slo_f5 * delta);       /* local F5 freq */
              pha_n5 = pha_n5 + ((pi2 * freq) * sampd) + add;
              f5_rel = (B5a + (slo_b5 * delta))/100;
              y      =      (f1_rel) * sin(pha_n1)  ;
              y      = y + ((f2_rel) * sin(pha_n2)) ;
              y      = y + ((f3_rel) * sin(pha_n3)) ;
              y      = y + ((f4_rel) * sin(pha_n4)) ;
              y      = y + ((f5_rel) * sin(pha_n5)) ;
              ampl   = intnoi1 + (slo_noi * delta);
              yn     = y * ampl;     /* unvoiced part of the period
----------------------------------------------------------------------- */
              yint = (int) (yv + yn);

              fwrite (&yint,2,1,usp);
              point = point + sampd;
              gro++;
             }

       fra_start = point - sampd;



 }                           /* end pitch periods loop */

fclose (usp);
usp = fopen(uspfile,"rb");

/* bertragen in WAV- Datei mit Header */

     strncpy                 (head.RIFF,"RIFF",4);
     head.FILE_LENGTH    =   (gro * 2) + 36;
     strncpy                 (head.WAVEFMT,    "WAVEfmt ",8);
     head.HEAD_LENGTH    =   16;
     head.ONE            =   1;
     head.N_CHANNELS     =   1;
     head.SAMPLINGRATE   =   (unsigned long int) sampr;
     head.BYTEPERSECOND  =   2 * ((unsigned long int) sampr);
     head.BYTEPERSAMPLE  =   2 ;
     head.BITPERSAMPLE   =   16 ;
     strncpy                 (head.DATA,"data",4);
     head.BYTEOFDATA     =   gro * 2 ;

fwrite (&head,44,1,wav);

n=0;
while (n++ < gro)
       {
        fread (&yint,2,1,usp);
        fwrite (&yint,2,1,wav);
       }

printf ("File %s synthesized from %s \n",argv[2],argv[1]);
exit (0);
}
/* ********************** Programmende ************************** */
